class  MyFitFun {
public:
  double Evaluate(double *xPtr, double *parPtr) {
    double fitVal = 0.0;
    double xVal = *xPtr;


    double vMag   = parPtr[0];
    double vMean  = parPtr[1];
    double vGamma = parPtr[2];
    double vSigma = parPtr[3];

    double vMag2   = parPtr[4];
    double vMean2  = parPtr[5];
    double vGamma2 = parPtr[6];
    double vSigma2 = parPtr[7];
    vSigma2 = vSigma;

    double voigtFun1 = TMath::Voigt(xVal-vMean,vSigma,vGamma);
    double voigtFun2 = TMath::Voigt(xVal-vMean2,vSigma2,vGamma2);

                                                 
    double p0Val = parPtr[8];
    double p1Val = parPtr[9];
    double p2Val = parPtr[10];

    //Background function
    double bkg = fabs(p0Val + p1Val*xVal + p2Val*xVal*xVal);

    fitVal =  vMag*voigtFun1 + vMag2*voigtFun2 + bkg;

    return fitVal;
  }
};



void makePics(int iShow){
  gROOT->Reset();
  gROOT->SetStyle("Plain");
  gStyle->SetOptStat(0);


  TFile *hFile = new TFile("./all_kpkmpi0.root");
  TFile *hFile2 = new TFile("./fitted.root");

  TH1D *hMassX; hFile2->GetObject("hMassX",hMassX);
  TH1D *hMassXB; hFile2->GetObject("hMassXB",hMassXB);
  TH1D *hMassXAll; hFile2->GetObject("hMassXAll",hMassXAll);

  TH2D *hMassD4Q; hFile->GetObject("hKpKmVsKpKmPi0CutD4Q",hMassD4Q);
  TH2D *hMassD4Q2; hFile->GetObject("hKpKmVsKpKmPi0CutD4Q2",hMassD4Q2);
  TH2D *hMassD4Q3; hFile->GetObject("hKpKmVsKpKmPi0CutD4Q3",hMassD4Q3);

  TH2D *hMassKStarKStar; hFile->GetObject("hKpPi0VsKmPi0CutD4",hMassKStarKStar);

  TH1D *hMassD4Q_px = hMassD4Q->ProjectionX("hMassD4Q_px");
  TH1D *hMassD4Q2_px = hMassD4Q2->ProjectionX("hMassD4Q2_px");
  TH1D *hMassD4Q3_px = hMassD4Q3->ProjectionX("hMassD4Q3_px");

  hMassD4Q_px->SetLineColor(1);
  hMassD4Q_px->SetLineWidth(2);
  hMassD4Q2_px->SetLineWidth(2);
  hMassD4Q3_px->SetLineWidth(2);
  hMassD4Q_px->GetXaxis()->SetRangeUser(1.1,2.5);
  hMassD4Q_px->GetXaxis()->SetLabelFont(62);
  hMassD4Q_px->GetXaxis()->SetLabelSize(0.04);
  hMassD4Q_px->GetYaxis()->SetLabelSize(0.04);

  hMassD4Q_px->GetYaxis()->SetTitle("Counts");
  hMassD4Q_px->GetYaxis()->SetTitleOffset(1.3);
  hMassD4Q_px->GetXaxis()->SetTitleFont(62);
  hMassD4Q_px->GetXaxis()->SetTitle("Mass[K^{+}K^{-}#pi^{0}]/GeV");
  hMassD4Q_px->GetXaxis()->SetTitleOffset(1.2);

  hMassD4Q2_px->SetLineColor(2);
  hMassD4Q3_px->SetLineColor(4);
  if(iShow == 1){
    hMassD4Q_px->Draw("");
    hMassD4Q3_px->Draw("same");
    hMassD4Q2_px->Draw("same");
  }
  hMassKStarKStar->GetXaxis()->SetRangeUser(0.5,2.0);
  hMassKStarKStar->GetYaxis()->SetRangeUser(0.5,2.0);
  hMassKStarKStar->GetXaxis()->SetTitleFont(62);
  hMassKStarKStar->GetYaxis()->SetTitleFont(62);
  hMassKStarKStar->GetYaxis()->SetTitle("Mass[K^{+}#pi^{0}]/GeV");
  hMassKStarKStar->GetXaxis()->SetTitle("Mass[K^{-}#pi^{0}]/GeV");
  hMassKStarKStar->GetXaxis()->SetLabelFont(62);
  hMassKStarKStar->GetYaxis()->SetLabelFont(62);
  hMassKStarKStar->GetXaxis()->SetLabelSize(0.04);
  hMassKStarKStar->GetYaxis()->SetLabelSize(0.04);

  if(iShow == 2){
    hMassKStarKStar->Draw("colz");
  }
  hMassXAll->GetYaxis()->SetTitle("Counts");
  hMassXAll->GetXaxis()->SetTitle("Mass[K^{+}K^{-}#pi^{0}]/GeV");
  hMassXAll->GetYaxis()->SetTitleOffset(1.2);
  if(iShow == 3){
    hMassXAll->Draw("colz");
    hMassXB->Draw("SameHist");
    hMassX->SetLineColor(7);
    hMassX->Draw("eSame");
  }
  hMassXB->GetXaxis()->SetRangeUser(1.2,2.2);
  hMassXB->GetYaxis()->SetTitle("Counts");
  hMassXB->GetXaxis()->SetTitle("Mass[K^{+}K^{-}#pi^{0}]/GeV");
  hMassXB->GetYaxis()->SetTitleOffset(1.2);
  if(iShow == 4){
    hMassXB->Draw("Hist");
  }

  if(iShow == 5){
    int nPar = 11;
    MyFitFun * fptr = new MyFitFun();
    TF1 *f2 = new TF1("f2",fptr,&MyFitFun::Evaluate,0.0,4.0,nPar,
		      "MyFitFun","Evaluate");
    f2->SetParameter(0,15);
    f2->SetParameter(1,1.285);
    f2->SetParameter(2,0.02);
    f2->FixParameter(3,0.007);
    f2->SetParameter(4,97);
    f2->SetParameter(5,1.403);
    f2->SetParameter(6,0.05);
    f2->FixParameter(7,0.007);
    f2->SetParameter(8,0.0);
    f2->SetParameter(9,0.0);
    f2->SetParameter(10,0.0);

    //hMassXB->Fit("f2","","R",1.24,1.5);//Works
    hMassXB->Fit("f2","","R",1.24,1.6);
    hMassXB->GetXaxis()->SetRangeUser(1.24,1.6);
    hMassXB->Draw();

  }
}
